/******************** (C) COPYRIGHT 2007 STMicroelectronics ********************
* File Name          : main.c
* Author             : MCD Application Team
* Date First Issued  : 02/05/2007
* Description        : Main program body
********************************************************************************
* History:
* 05/21/2007: V0.3
* 04/02/2007: V0.2
* 02/05/2007: V0.1
********************************************************************************
* THE PRESENT SOFTWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME.
* AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY DIRECT,
* INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE
* CONTENT OF SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING
* INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*******************************************************************************/

/* Includes ------------------------------------------------------------------*/
#include "spi_flash.h"
//#include "spi_rf.h"
#include <stdio.h>
#include "main.h"

#define   MASTER    1
#define   SLAVER    0

/* Local includes ------------------------------------------------------------*/
/* Private typedef -----------------------------------------------------------*/
typedef enum {FAILED = 0, PASSED = !FAILED} TestStatus;

/* Private define ------------------------------------------------------------*/
#define  FLASH_WriteAddress     0x00000000
#define  FLASH_ReadAddress      FLASH_WriteAddress
#define  FLASH_SectorToErase    FLASH_WriteAddress
#define  M25P64_FLASH_ID        0x202017
#define  BufferSize (countof(Tx_Buffer)-1)

/* Private macro -------------------------------------------------------------*/
#define countof(a) (sizeof(a) / sizeof(*(a)))

/* Private variables ---------------------------------------------------------*/
static vu32 TimingDelay = 0; 
u8 Tx_Buffer[] = "STM32F10x SPI Firmware Library Example: communication with an M25P64 SPI FLASH";
u8 i, Rx_Buffer[BufferSize];
volatile TestStatus TransferStatus1 = FAILED, TransferStatus2 = PASSED;
vu32 FLASH_ID = 0;
ErrorStatus HSEStartUpStatus;
u8 test_value;

u8 length;
u8 payload[64];
bool  b_receive_ack;

/* Private functions ---------------------------------------------------------*/
TestStatus Buffercmp(u8* pBuffer1, u8* pBuffer2, u16 BufferLength);
void RCC_Configuration(void);
void GPIO_Configuration(void);
void NVIC_Configuration(void);
void usart1(void);


/*******************************************************************************
* Function Name  : main
* Description    : Main program
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
int main(void)
{
	
	
	
#ifdef DEBUG
  debug();
#endif

  /* System clocks configuration ---------------------------------------------*/
  RCC_Configuration();

  /* NVIC configuration ------------------------------------------------------*/
  NVIC_Configuration();
  
  /* Configure the systick */    
  SysTick_Config();
  /* Initialize the LCD */
  

  /* GPIO configuration ------------------------------------------------------*/
  GPIO_Configuration();

 
  
  init_4432();
	
	//SpiWriteRegister(0x1c, 0x47);	
  //test_value = SpiReadRegister(0x1c); 
		
#if   0 //slave

  while(1)
  {
		   if(GPIO_ReadInputDataBit(GPIOC, GPIO_Pin_13) == 0x00)
			 {
				   mDelay(0x200);
        	 if(GPIO_ReadInputDataBit(GPIOC, GPIO_Pin_13) == 0x00)
					 {
						   LED_RED_ON();
				       LED_GRE_OFF();
						   mDelay(0x200); 
						   while(GPIO_ReadInputDataBit(GPIOC, GPIO_Pin_13) == 0x00);
						   mDelay(0x200); 
						   sending();
						   
						   LED_RED_OFF();
				       LED_GRE_OFF();
						 
						   
               mDelay(0x720000);
						  
						   b_receive_ack =0;
						   receive();
				   
					 }						 
				 
			 }
          
  }
	
#else
	
	while(1)
  {
       b_receive_ack =0;
       receive_ack();
		   
  }

	

	
#endif


  
}

void receive_ack(void)
{
	u8 ItStatus1;
	u8 ItStatus2;
	u8 temp8;
	
	     LED_RED_OFF();
	     LED_GRE_OFF();
	     if(GPIO_ReadInputDataBit(GPIOB, GPIO_Pin_10) == 0x00)
			 {
				    
					    //disable the receiver chain
					    SpiWriteRegister(0x07, 0x01);													//write 0x01 to the Operating Function Control 1 register
					    //read interrupt status registers
					    ItStatus1 = SpiReadRegister(0x03);											//read the Interrupt Status1 register
					    ItStatus2 = SpiReadRegister(0x04);											//read the Interrupt Status2 register

					    /*CRC Error interrupt occured*/
					    if ( (ItStatus1 & 0x01) == 0x01 )
					    {
						       //reset the RX FIFO
						       SpiWriteRegister(0x08, 0x02);												//write 0x02 to the Operating Function Control 2 register
						       SpiWriteRegister(0x08, 0x00);												//write 0x00 to the Operating Function Control 2 register
						      //blink all LEDs to show the error
						
						
					    }

					    /*packet received interrupt occured*/
					    if ( (ItStatus1 & 0x02) == 0x02 )
					    {
						          //Read the length of the received payload
						       length = SpiReadRegister(0x4B);											//read the Received Packet Length register
						       //check whether the received payload is not longer than the allocated buffer in the MCU
						       if (length ==64)
						       {
							         //Get the reeived payload from the RX FIFO
							         for (temp8=0;temp8 < length;temp8++)
							         {
								             payload[temp8] = SpiReadRegister(0x7F);						//read the FIFO Access register
							                
                       }
											 
                       if((payload[0]==0x00)&&(payload[5]==0x05))
											 {
												   LED_RED_ON();
							             LED_GRE_ON();
												   mDelay(0x20000);	
                           //mDelay(0x20000);		
                           //mDelay(0x20000);		
                           											   
				                   //sending();
												   //sending();
												   //sending();
												   sending();
											 }
							         

						        }
					     }



					//reset the RX FIFO
					SpiWriteRegister(0x08, 0x02);													//write 0x02 to the Operating Function Control 2 register
					SpiWriteRegister(0x08, 0x00);													//write 0x00 to the Operating Function Control 2 register
					//enable the receiver chain again
					SpiWriteRegister(0x07, 0x05);													//write 0x05 to the Operating Function Control 1 register
			 }
}

void receive(void)
{
	u8 ItStatus1;
	u8 ItStatus2;
	u8 temp8;
	
	     LED_RED_OFF();
	     LED_GRE_OFF();
	     if(GPIO_ReadInputDataBit(GPIOB, GPIO_Pin_10) == 0x00)
			 {
				    
					    //disable the receiver chain
					    SpiWriteRegister(0x07, 0x01);													//write 0x01 to the Operating Function Control 1 register
					    //read interrupt status registers
					    ItStatus1 = SpiReadRegister(0x03);											//read the Interrupt Status1 register
					    ItStatus2 = SpiReadRegister(0x04);											//read the Interrupt Status2 register

					    /*CRC Error interrupt occured*/
					    if ( (ItStatus1 & 0x01) == 0x01 )
					    {
						       //reset the RX FIFO
						       SpiWriteRegister(0x08, 0x02);												//write 0x02 to the Operating Function Control 2 register
						       SpiWriteRegister(0x08, 0x00);												//write 0x00 to the Operating Function Control 2 register
						      //blink all LEDs to show the error
						
						
					    }

					    /*packet received interrupt occured*/
					    if ( (ItStatus1 & 0x02) == 0x02 )
					    {
						          //Read the length of the received payload
						       length = SpiReadRegister(0x4B);											//read the Received Packet Length register
						       //check whether the received payload is not longer than the allocated buffer in the MCU
						       if (length ==64)
						       {
							         //Get the reeived payload from the RX FIFO
							         for (temp8=0;temp8 < length;temp8++)
							         {
								             payload[temp8] = SpiReadRegister(0x7F);						//read the FIFO Access register
							         }
											 
                       if((payload[0]==0x00)&&(payload[5]==0x05))
											 {
												   LED_RED_ON();
							             LED_GRE_ON();
												   b_receive_ack =1;
												    
											 }
							         

						        }
					     }



					//reset the RX FIFO
					SpiWriteRegister(0x08, 0x02);													//write 0x02 to the Operating Function Control 2 register
					SpiWriteRegister(0x08, 0x00);													//write 0x00 to the Operating Function Control 2 register
					//enable the receiver chain again
					SpiWriteRegister(0x07, 0x05);													//write 0x05 to the Operating Function Control 1 register
			 }
}

void sending(void)
{
		u16 delay;
	    u8 ItStatus1;
	    u8 ItStatus2;
	    u8 i;


	        //Wait for releasing the push button
			//while( PB == 0 );
			//disable the receiver chain (but keep the XTAL running to have shorter TX on time!)
			SpiWriteRegister(0x07, 0x01);													//write 0x01 to the Operating Function Control 1 register			
      //mDelay(0x2000);
			//turn on the LED to show the packet transmission
			
	    //reset the RX FIFO
			//SpiWriteRegister(0x08, 0x01);													//write 0x02 to the Operating Function Control 2 register
			//SpiWriteRegister(0x08, 0x00);													//write 0x00 to the Operating Function Control 2 register																			
			
	    /*SET THE CONTENT OF THE PACKET*/
			//set the length of the payload to 8bytes	
			SpiWriteRegister(0x3E, 64);		//write 8 to the Transmit Packet Length register		
	    for(i=0;i<64;i++)
			{
				SpiWriteRegister(0x7F, i);	
			}
	   
	
	   
	 
/*	 
	//fill the payload into the transmit FIFO
			SpiWriteRegister(0x7F, 0x50);													//write 0x42 ('B') to the FIFO Access register	
			SpiWriteRegister(0x7F, 0x51);													//write 0x55 ('U') to the FIFO Access register	
			SpiWriteRegister(0x7F, 0x52);													//write 0x54 ('T') to the FIFO Access register	
			SpiWriteRegister(0x7F, 0x53);													//write 0x54 ('T') to the FIFO Access register	
			SpiWriteRegister(0x7F, 0x54);													//write 0x4F ('O') to the FIFO Access register	
			SpiWriteRegister(0x7F, 0x55);													//write 0x4E ('N') to the FIFO Access register	
			SpiWriteRegister(0x7F, 0x56);													//write 0x31 ('1') to the FIFO Access register	
			SpiWriteRegister(0x7F, 0x57);													//write 0x0D (CR) to the FIFO Access register	
*/
			//Disable all other interrupts and enable the packet sent interrupt only.
			//This will be used for indicating the successfull packet transmission for the MCU
			SpiWriteRegister(0x05, 0x04);													//write 0x04 to the Interrupt Enable 1 register	
			SpiWriteRegister(0x06, 0x00);													//write 0x03 to the Interrupt Enable 2 register	
			//Read interrupt status regsiters. It clear all pending interrupts and the nIRQ pin goes back to high.
			ItStatus1 = SpiReadRegister(0x03);											//read the Interrupt Status1 register
			ItStatus2 = SpiReadRegister(0x04);											//read the Interrupt Status2 register

			/*enable transmitter*/
			//The radio forms the packet and send it automatically.
			SpiWriteRegister(0x07, 0x09);													//write 0x09 to the Operating Function Control 1 register
      mDelay(0x20);
			/*wait for the packet sent interrupt*/
			//The MCU just needs to wait for the 'ipksent' interrupt.
			while(GPIO_ReadInputDataBit(GPIOB, GPIO_Pin_10) != 0x00);    //while(NIRQ == 1);
			//read interrupt status registers to release the interrupt flags
			ItStatus1 = SpiReadRegister(0x03);											//read the Interrupt Status1 register
			ItStatus2 = SpiReadRegister(0x04);											//read the Interrupt Status2 register

       
			//wait a bit for showing the LED a bit longer
			//mDelay(0x20000);
			//for(delay = 0; delay < 10000;delay++);
			//for(delay = 0; delay < 60000;delay++);
			//turn off the LED
			//TX_LED = 0; 
			
			//after packet transmission set the interrupt enable bits according receiving mode
			//Enable two interrupts: 
			// a) one which shows that a valid packet received: 'ipkval'
			// b) second shows if the packet received with incorrect CRC: 'icrcerror' 
			SpiWriteRegister(0x05, 0x03); 												//write 0x03 to the Interrupt Enable 1 register
			SpiWriteRegister(0x06, 0x00); 												//write 0x00 to the Interrupt Enable 2 register
			//read interrupt status registers to release all pending interrupts
			ItStatus1 = SpiReadRegister(0x03);											//read the Interrupt Status1 register
			ItStatus2 = SpiReadRegister(0x04);											//read the Interrupt Status2 register

			/*enable receiver chain again*/
			SpiWriteRegister(0x07, 0x05);	   
	
}

/*******************************************************************************
* Function Name  : RCC_Configuration
* Description    : Configures the different system clocks.
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void RCC_Configuration(void)
{
  /* RCC system reset(for debug purpose) */
  RCC_DeInit();

  /* Enable HSE */
  RCC_HSEConfig(RCC_HSE_ON);

  /* Wait till HSE is ready */
  HSEStartUpStatus = RCC_WaitForHSEStartUp();

  if(HSEStartUpStatus == SUCCESS)
  {
    /* HCLK = SYSCLK */
    RCC_HCLKConfig(RCC_SYSCLK_Div1); 
   
    /* PCLK2 = HCLK */
    RCC_PCLK2Config(RCC_HCLK_Div1); 
    
    /* PCLK1 = HCLK/2 */
    RCC_PCLK1Config(RCC_HCLK_Div2);
      
    /* Flash 2 wait state */
    FLASH_SetLatency(FLASH_Latency_2);
    /* Enable Prefetch Buffer */
    FLASH_PrefetchBufferCmd(FLASH_PrefetchBuffer_Enable);

    /* PLLCLK = 8MHz * 9 = 72 MHz */
    RCC_PLLConfig(RCC_PLLSource_HSE_Div1, RCC_PLLMul_9);

    /* Enable PLL */ 
    RCC_PLLCmd(ENABLE);

    /* Wait till PLL is ready */
    while(RCC_GetFlagStatus(RCC_FLAG_PLLRDY) == RESET)
    {
    }

    /* Select PLL as system clock source */
    RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK);

    /* Wait till PLL is used as system clock source */
    while(RCC_GetSYSCLKSource() != 0x08)
    {
    }
  }

/* Enable peripheral clocks --------------------------------------------------*/
  /* Enable GPIOF clock */
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOF, ENABLE);
}

/*******************************************************************************
* Function Name  : GPIO_Configuration
* Description    : Configures the different GPIO ports.
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void GPIO_Configuration(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE );
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE );
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC, ENABLE );

  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0| GPIO_Pin_1;//LED
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  GPIO_Init(GPIOB, &GPIO_InitStructure);

  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0| GPIO_Pin_1;//KEY2 3
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
  GPIO_Init(GPIOA, &GPIO_InitStructure);

  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_13;//KEY1
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
  GPIO_Init(GPIOC, &GPIO_InitStructure);

  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5| GPIO_Pin_6| GPIO_Pin_7| GPIO_Pin_8| GPIO_Pin_9;//LED
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  GPIO_Init(GPIOB, &GPIO_InitStructure);


}

/*******************************************************************************
* Function Name  : NVIC_Configuration
* Description    : Configures Vector Table base location.
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void NVIC_Configuration(void)
{
#ifdef  VECT_TAB_RAM  
  /* Set the Vector Table base location at 0x20000000 */ 
  NVIC_SetVectorTable(NVIC_VectTab_RAM, 0x0); 
#else  /* VECT_TAB_FLASH  */
  /* Set the Vector Table base location at 0x08000000 */ 
  NVIC_SetVectorTable(NVIC_VectTab_FLASH, 0x0);   
#endif
}

/*******************************************************************************
* Function Name  : Buffercmp
* Description    : Compares two buffers.
* Input          : - pBuffer1, pBuffer2: buffers to be compared.
*                : - BufferLength: buffer's length
* Output         : None
* Return         : PASSED: pBuffer1 identical to pBuffer2
*                  FAILED: pBuffer1 differs from pBuffer2
*******************************************************************************/
TestStatus Buffercmp(u8* pBuffer1, u8* pBuffer2, u16 BufferLength)
{
  while(BufferLength--)
  {
    if(*pBuffer1 != *pBuffer2)
    {
      return FAILED;
    }
    
    pBuffer1++;
    pBuffer2++;
  }

  return PASSED;  
}

#ifdef  DEBUG
/*******************************************************************************
* Function Name  : assert_failed
* Description    : Reports the name of the source file and the source line number
*                  where the assert error has occurred.
* Input          : - file: pointer to the source file name
*                  - line: assert error line source number
* Output         : None
* Return         : None
*******************************************************************************/
void assert_failed(u8* file, u32 line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/*******************************************************************************
* Function Name  : SysTick_Config
* Description    : Configure a SysTick Base time to 10 ms.
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
 void SysTick_Config(void)
{
  /* Configure HCLK clock as SysTick clock source */
  SysTick_CLKSourceConfig(SysTick_CLKSource_HCLK);
 
  /* SysTick interrupt each 100 Hz with HCLK equal to 72MHz */
  SysTick_SetReload(720000);

  /* Enable the SysTick Interrupt */
  SysTick_ITConfig(ENABLE);
}

/*******************************************************************************
* Function Name  : Delay
* Description    : Inserts a delay time.
* Input          : nCount: specifies the delay time length (time base 10 ms).
* Output         : None
* Return         : None
*******************************************************************************/
void Delay(u32 nCount)
{
  TimingDelay = nCount;

  /* Enable the SysTick Counter */
  SysTick_CounterCmd(SysTick_Counter_Enable);
  
  while(TimingDelay != 0)
  {
  }

  /* Disable the SysTick Counter */
  SysTick_CounterCmd(SysTick_Counter_Disable);

  /* Clear the SysTick Counter */
  SysTick_CounterCmd(SysTick_Counter_Clear);
}

/*******************************************************************************
* Function Name  : Decrement_TimingDelay
* Description    : Decrements the TimingDelay variable.
* Input          : None
* Output         : TimingDelay
* Return         : None
*******************************************************************************/
void Decrement_TimingDelay(void)
{
  if (TimingDelay != 0x00)
  {
    TimingDelay--;
  }
}

void mDelay(u32 nCount)
{
  while(nCount!=0)
  {
       nCount--;
	   ;
	   ;
	   ;
  }

  
}

/******************* (C) COPYRIGHT 2007 STMicroelectronics *****END OF FILE****/
