/******************** (C) COPYRIGHT 2007 STMicroelectronics ********************
* File Name          : spi_flash.h
* Author             : MCD Application Team
* Date First Issued  : 02/05/2007
* Description        : Header for spi_flash.c file.
********************************************************************************
* History:
* 05/21/2007: V0.3
* 04/02/2007: V0.2
* 02/05/2007: V0.1
********************************************************************************
* THE PRESENT SOFTWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME.
* AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY DIRECT,
* INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE
* CONTENT OF SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING
* INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*******************************************************************************/

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __SPI_FLASH_H
#define __SPI_FLASH_H

/* Includes ------------------------------------------------------------------*/
#include "stm32f10x_lib.h"


/* Exported types ------------------------------------------------------------*/
/* Exported constants --------------------------------------------------------*/
/* Exported macro ------------------------------------------------------------*/
/* Select SPI FLASH: ChipSelect pin low  */
#define SPI_RF_SDN_LOW()     GPIO_ResetBits(GPIOB, GPIO_Pin_11)
#define SPI_RF_SDN_HIGH()    GPIO_SetBits(GPIOB, GPIO_Pin_11)

#define SPI_RF_CS_LOW()     GPIO_ResetBits(GPIOB, GPIO_Pin_12)
#define SPI_RF_CS_HIGH()    GPIO_SetBits(GPIOB, GPIO_Pin_12)

//#define SPI_RF_CE_LOW()     GPIO_ResetBits(GPIOB, GPIO_Pin_11)
//#define SPI_RF_CE_HIGH()    GPIO_SetBits(GPIOB, GPIO_Pin_11)

/* Exported functions ------------------------------------------------------- */


void init_4432(void);

/*----- Low layer function -----*/
u8 SPI_RF_ReadByte(void);
u8 SPI_RF_SendByte(u8 byte);
void SpiWriteRegister (u8 reg, u8 value);
U8 SpiReadRegister (u8 reg);
extern void mDelay(u32 nCount);

#endif /* __SPI_FLASH_H */

/******************* (C) COPYRIGHT 2007 STMicroelectronics *****END OF FILE****/
